<?php  require("../../code.php");
ronja_header("Twig program documentation");
?>
<h1>Features</h1>
<div style="float: right; clear: both; margin-left: 1em;">
<?php 
obr2("1ebd");
?>
</div>
<p>Twig is an image gallery program. You have a directory with
subdirectory structure with images. Twig generates for each image 3 levels
of diminished images and 3 level of thumbnails:
<table border=1><tr><td>Level</td><td>Size</td></tr>
<tr><td>0</td><td>64x64</td></tr>
<tr><td>1</td><td>128x128</td></tr>
<tr><td>2</td><td>256x256</td></tr>
<tr><td>3</td><td>35%</td></tr>
<tr><td>4</td><td>50%</td></tr>
<tr><td>5</td><td>71%</td></tr>
</table></p>

<p>Twig keeps a clickable structure of HTML files, each directory has an
own HTML page with listing and each file has own HTML page with links to
various sizes of the images under thumbnails and with EXIF information
and image comment.</p>

<p>Twig can work with JPG and PNG images. Maybe also with GIFs but I am
not sure ;-)</p>

<p>If you change anything in the gallery (add directories, files, change
files, delete files), you just need to rerun the &quot;regen&quot; script.
Twig automatically detects all changes and updated in the HTML structure.
Thumbnails and scaled down images are automatically regenerated if needed.
Most time-intensive work is however not done if not necessary.</p>

<h2>Identifiers</h2>
<p>Twig assigns every image an unique hexadecimal identifier. If an image
is deleted, the identifier remains unused. Twig is written with 128 bits
allocated for the identifier, so it is physically impossible
to exhaust the identifiers.</p>

<p>The purpose of the identifiers is to allow simple linking of images
from webpages with just specifying the identifier. The identifiers are
stored in tns/database which is in GDBM format. Back up this file
frequently as damage to it can destroy all the image links on your
website.</p>

<h2>Comments</h2>
<p>JPEG comments of the JPEG images are parsed. The part of the comment up
to first newline is displayed under the image thumbnail in directory
listings. The whole comment is then displayed on the image's own HTML
page. Newlines in the comment are replaced by paragraph separators.</p>

<h2>Atomicity</h2>
<p>Updating the gallery is atomic. If you run the update and break it
in the middle, you don't get an inconsistent state. Regenerated thumbnails
and downsized images are moved to the destination immediately, the rest
is put into a directory aside and then moved at once.</p>

<h2>Ronja</h2>
<p>Twig was written for the Ronja website. If the directory name is
&quot;ronja&quot; (now I don't remember if it works only for toplevel
or also for lower levels), the HTML pages will be generated with a heading
of Ronja and Twibright labs logo.</p>

<h1>Download</h1>
<p>Download <a href="/utils/twig/twig.tgz">twig.tgz</a>.</p>

<h1>Requirements</h1>
<p>You need the following software to run Twig:
<ul><li><a href="http://en.wikipedia.org/wiki/Linux">Linux</a>
or <a href="http://openbsd.org/">OpenBSD</a>. You can try on different unix-like system
and report errors if it doesn't work for you.</li>
<li><a href="http://www.imagemagick.org/">ImageMagick</a>
(works with 6.2.8) with PNG support - the &quot;convert&quot; and
&quot;identify&quot; commands are used.</li>
<li><a href="http://www.sentex.net/~mwandel/jhead/">jhead</a>
(works with v2.2)</li>
<li>
Idependent JPEG Group <a href="http://www.ijg.org/">libjpeg</a>
- the &quot;rdjpegcom&quot; program is used.</li>
</ul>

<h2>Installation</h2>
<ul><li>Create a directory for your images (let's call it
&quot;grxmaster&quot;).</li>
<li>Put the Twig files into grxmaster:
Makefile, data.c, data.h, findscript, foder.gif, index_template.html, manager.c,
mvscript, regen, rmscript.</li>
<li>Rename index_template.html to index.html and perform changes you want.</li>
<li>Go into grxmaster and type &quot;make&quot;. If the compilation
blows up, complain to the author (see contact below).</li>
</ul>

<h2>Usage</h2>
<ul>
<li>Create directory grxmaster/images.</li>
<li>Put your images into grxmaster/images. You can create subdirectories
inside the images directory and put some images into them if you want to
organize your images into subdirectories.</li>
<li>Go into grxmaster and run the &quot;regen&quot; script. It can take
some time.</li>
<li>Now load grxmaster/index.html into your web browser and you are
already viewing your gallery</li>
<li>To link to a directory, first find the directory from index.html.
The hexadecimal identifier will be in the heading of the directory,
example: [1552]. To link to this directory, use
.../grxmaster/tns/1552.html.</li>
<li>Link to images the same way as to a directory, just use the identifier
from the image page where it is printed in the heading too.</li>
<li>To refer to thumbnails, use grxmaster/tns/lvl0/1552.html, where
lvl0 can be replaced by lvl0-lvl5, depending on the size you want.</li>
</ul>

<h1>Author, contact</h1>
<p>Twig was written by Karel 'Clock' Kulhavy,
Write bugreports to this e-mail:<?_insertimage("/grx/spam@spam.com"); ?></p>

<h1>Licence</h1>
<p>Twig is under GPL.</p>

<h1>Internal doc</h1>
<h2>Thumbnail directories</h2>
<table border=1><tr><td>Thumbnail directory name</td><td>Size</td></tr>
<tr><td>lvl0</td><td>64x64</td></tr>
<tr><td>lvl1</td><td>128x128</td></tr>
<tr><td>lvl2</td><td>256x256</td></tr>
<tr><td>lvl3</td><td>35%</td></tr>
<tr><td>lvl4</td><td>50%</td></tr>
<tr><td>lvl5</td><td>71%</td></tr>
</table>
<?php  footer(); ?>
